<?php
add_action('wp_head', 'qcld_express_ajaxurl');
function qcld_express_ajaxurl()
{
    echo '<script type="text/javascript">
           var ajaxurl = "' . admin_url('admin-ajax.php') . '";
           var image_loader = "' . QCLD_EXPRESS_IMG_URL . '/product-loader.gif";
           var currency_symbol = "' . get_woocommerce_currency_symbol() . '" ;
         </script>';
}

add_action('wp_ajax_get_vp_attributes', 'qcld_express_get_v_product');
add_action('wp_ajax_nopriv_get_vp_attributes', 'qcld_express_get_v_product');


function qcld_express_get_v_product()
{
    //$attributes = $product->get_attributes();
    $p_id = trim($_POST['p_id']);
    $inStock = "<strong>InStock</strong>";
    //Woocommerce product factory
    $wc_pf = new WC_Product_Factory();
    $product = $wc_pf->get_product($p_id);
    //Getting product variation number based details
    $variations_data = array();
    foreach ($product->get_children() as $child_id) {
        //$variation = $product->get_child( $child_id );
        $all_cfs = get_post_custom($child_id);
        array_push($variations_data, array('variation_id' => $child_id, 'variation_data' => $all_cfs));
    }
    $variations_data = json_encode($variations_data);
    //Attributes for vaiable product to display.
    $attributes = $product->get_attributes();
   /* $var_attrs=$product->get_variation_attributes();
    $varation_names=array();
       if(!empty($var_attrs)){
           foreach ($var_attrs as $key=>$value){
               array_push($varation_names,$key);
           }
       }
    $debug=$varation_names;*/
    //Showing configure data.
    $table = '<div class="qcld-express-popup-table"><div class="qcld-express-popup-row"><div class="qcld-express-popup-col-12">';
    $table .= "<h2 id='qcld_epress_product_title' data-product-variation='" . $variations_data . "' >" . $product->get_title() . "</h3> </div> </div>";
    $table .= '<div class="qcld-express-popup-row"><div class="qcld-express-popup-col-6"><p class="qcld-express-popup-price" id="qcld_express_vp_price">' . $product->get_price_html() . '</p>
   </div>';
    $table .= '<div class="qcld-express-popup-col-6"><p class="qcld-express-popup-sku"> SKU : ' . $product->get_sku() . '</p>
   </div> </div>';

    foreach ($attributes as $attribute) {
       /* if (empty($attribute['is_visible']) || ($attribute['is_taxonomy'] && !taxonomy_exists($attribute['name']))) {
            continue;
        }*/

        $title = wc_attribute_label($attribute['name']);
        $name = $attribute['name'];

        if ($attribute['is_taxonomy']) {
            $values = wc_get_product_terms($product->get_id(), $attribute['name'], array('fields' => 'names'));
        } else {
            $values = array_map('trim', explode(WC_DELIMITER, $attribute['value']));
        }

        natsort($values);
        $table .= '<div class="qcld-express-popup-row">
                    <div class="qcld-express-popup-col-12">
					<label for="' . sanitize_title($name) . '">' . $title . '</label>';
        $table .= '<select id="' . esc_attr(sanitize_title($name)) . '" name="attribute_' . sanitize_title($name) . '" data-attribute_name="attribute_' . sanitize_title($name) . '" class="each_attribute">';
        //$table.='<option value="">'. __( 'Choose an option', 'woocommerce' ).'&hellip;</option>';
        foreach ($values as $value) {
            if (isset($_REQUEST['attribute_' . sanitize_title($name)])) {
                $selected_value = $_REQUEST['attribute_' . sanitize_title($name)];
            } else {
                $selected_value = '';
            }
            $table .= '<option value="' . esc_attr(strtolower($value)) . '"' . selected($selected_value, $value, false) . '>' . apply_filters('woocommerce_variation_option_name', $value) . '</option>';
        }
        $table .= '</select>
					 </div>
				</div>';
    }
    $table .= '<div class="qcld-express-popup-row">
   <div class="qcld-express-popup-col-12"><label for="">Quantity</label>
   <input type="number" id="vPQuantity" value="1" /> </div> </div>';
    $table .= '<div class="qcld-express-popup-row">
         <div class="qcld-express-popup-col-12">
	<input type="button" id="v_p_add_to_cart" p-id="' . $p_id . '" value="Add to Cart" />
</div>
</div>
</div>
';
    echo wp_send_json($table);
    wp_die();
}

//Add to cart for simple product.
add_action('wp_ajax_sp_add_to_cart', 'qcld_express_sp_add_to_cart');
add_action('wp_ajax_nopriv_sp_add_to_cart', 'qcld_express_sp_add_to_cart');


function qcld_express_sp_add_to_cart()
{
    $product_id = $_POST['p_id'];
    global $woocommerce;
    $result = $woocommerce->cart->add_to_cart($product_id);
    if ($result != false) {
        echo wp_send_json('simple');
    } else {
        echo wp_send_json('error');
    }
    wp_die();
}

//Add to cart for variable product.
add_action('wp_ajax_vp_add_to_cart', 'qcld_express_vp_add_to_cart');
add_action('wp_ajax_nopriv_vp_add_to_cart', 'qcld_express_vp_add_to_cart');


function qcld_express_vp_add_to_cart()
{
    $product_id = $_POST['p_id'];
    $quantity = $_POST['quantity'];
    $variations_id = $_POST['variations_id'];
    $attrs = $_POST['attributes'];
    $attributes = array();
    foreach ($attrs as $attr) {
        $single = explode("#", $attr);
        if (isset($single[0])) {
            $a_name = explode("_", $single[0]);
        }
        $attributes[$a_name[2]] = $single[1];
    }
    global $woocommerce;
    $result = $woocommerce->cart->add_to_cart($product_id, $quantity, $variations_id, $attributes, null);
    echo wp_send_json($result);
    wp_die();
}

//Show cart after adding product to cart.
add_action('wp_ajax_show_cart', 'qcld_express_show_cart');
add_action('wp_ajax_nopriv_show_cart', 'qcld_express_show_cart');
function qcld_express_show_cart()
{
    global $woocommerce;

    $html = '<div class="qcld-express-show-cart-wrapper"><div class="qcld-express-cart-heading">
             <h2>Cart Summary</h2><button type="button"  id="show-cart-close" class="fa fa-times"></button>
             </div>';

    global $woocommerce;
    $items = $woocommerce->cart->get_cart();
    $itemCount = count($items);
    if ($itemCount >= 1) {


        $html .= '<div class="qcld-express-show-cart-data"><div class ="qcld-express-table">';
        $html .= '<div class="qcld-express-row"><div class="qcld-express-cell">Title</div><div class="qcld-express-cell">Thumnail</div><div class="qcld-express-cell">Quantity</div><div class="qcld-express-cell">Price</div></div>';
        foreach ($items as $item => $values) {
            //$_product = $values['data']->post;
            $_product = apply_filters('woocommerce_cart_item_product', $values['data'], $values, $item);
            //$_product   = apply_filters( 'woocommerce_cart_item_product', $cart_item['data'], $cart_item, $cart_item_key );
            //product image
            $getProductDetail = wc_get_product($values['product_id']);
            $price = get_post_meta($values['product_id'], '_price', true);

            $html .= '<div class="qcld-express-row">
                        <div class="qcld-express-cell qcld-express-title-cell"> <h3 class="qcld-express-title">' . $_product->get_title(). '</h3></div>
                        <div class="qcld-express-cell qcld-express-thumb-cell">' . $getProductDetail->get_image() . '</div>
                        <div class="qcld-express-cell qcld-express-quantity-cell">' . $values['quantity'] . '</div>
                        <div class="qcld-express-cell qcld-express-price-cell">' . apply_filters('woocommerce_cart_item_price', WC()->cart->get_product_price($_product), $values, $item) . '</div> </div>';
            //<td>' . get_woocommerce_currency_symbol() . '' . $price . '</td></tr>'

        }
        $html .= ' </div></div>';
    } else {
        $html .= '<div class="qcld_no_cartprods">You do not have any products in the cart</div>';
    }
    $html .= '<div class="qcld-express-cart-footer">
             <a href="' . get_site_url() . '/cart">Edit on Cart</a>
             <a href="' . get_site_url() . '/checkout">Checkout</a>
            </div>';
    $html .= '</div>';
    echo wp_send_json($html);
    wp_die();
}

add_action('wp_ajax_load_more', 'qcld_express_load_more');
add_action('wp_ajax_nopriv_load_more', 'qcld_express_load_more');

function qcld_express_load_more()
{
    //Getting option tree from backend.
    $qcld_express_options = get_option('qcld_express_options');
    $qcld_express_show_mode = $qcld_express_options['qcld_express_show_mode'];
    $qcld_express_sku = $qcld_express_options['qcld_express_sku'];
    $qcld_express_thumbnail = $qcld_express_options['qcld_express_thumbnail'];
    $qcld_express_title = $qcld_express_options['qcld_express_title'];
    $qcld_express_description = $qcld_express_options['qcld_express_description'];
    $qcld_express_price = $qcld_express_options['qcld_express_price'];
    $qcld_express_stock = $qcld_express_options['qcld_express_stock'];
    $qcld_express_stock_alert = $qcld_express_options['qcld_express_stock_alert'];
    $qcld_express_action = $qcld_express_options['qcld_express_action'];
    $qcld_express_background = $qcld_express_options['qcld_express_background'];
    $qcld_express_altern = $qcld_express_options['qcld_express_altern'];
    $qcld_express_custom_style = $qcld_express_options['qcld_express_custom_style'];
    if (isset($qcld_express_options['qcld_express_category'])) {
        $qcld_express_categories = $qcld_express_options['qcld_express_category'];
    } else {
        $qcld_express_categories = array();
    }
    $qcld_express_template = $qcld_express_options['qcld_express_template'];
    $qcld_express_product_per_page = $qcld_express_options['qcld_express_product_per_page'];
    //Now filtering the categories to pass to query.
    $terms = get_terms(array(
        'taxonomy' => 'product_cat',
        'hide_empty' => false,
    ));
    $categories = array();
    foreach ($terms as $term) {
        if (!in_array($term->term_id, $qcld_express_categories)) {
            array_push($categories, $term->term_id);
        }
    }
    $per_page = 15;
    //$per_page = $qcld_express_product_per_page;
    $offset = sanitize_text_field($_POST['offset']);
    //pulling up the product accroding to the query
    // Get WooCommerce Global from Qcld_woo_inc class.
    global $woocommerce;
    // Create query arguments array
    $query_args = array(
        'posts_per_page' => $per_page,
        'offset' => $offset,
        'category_in' => $categories,
        'post_status' => 'publish',
        'post_type' => 'product',
        'orderby' => array('menu_order' => 'ASC', 'title' => 'ASC')
    );
    // Add meta_query to query args
    $query_args['meta_query'] = array();

    // Check products stock status
    $query_args['meta_query'][] = $woocommerce->query->stock_status_meta_query();

    //Calculating nextoffset to show button or not.
    $products = get_posts($query_args);
    $products_num = count($products);
    if ($products_num == $per_page) {
        $nextOffset = intval($offset + $per_page);
    } else {
        $nextOffset = -1;
    }
    //Creating WooCommerce product factory.
    $wc_pf = new WC_Product_Factory();
    $html = '';
    $counter = 0;
    $qcld_express_slope_type = 'left';
    foreach ($products as $P) {
        $product = $wc_pf->get_product($P->ID);
        $getProductDetail = wc_get_product($P->ID);
        //Checking for image thumb.
        $qcld_thumb = wp_get_attachment_image_src(get_post_thumbnail_id($P->ID), 'shop_thumbnail');
        if (!empty($qcld_thumb)) {
            $image = $qcld_thumb;
        } else {
            $image[0] = QCLD_EXPRESS_IMG_URL . '/placeholder.png';
        }
        if ($counter % 2 == 0 && $qcld_express_template == "slope") {
            if ($qcld_express_slope_type == 'left') {
                $qcld_express_extra_class = "left-slope";
                $qcld_express_slope_type = 'right';
            } else {
                $qcld_express_extra_class = "right-slope";
                $qcld_express_slope_type = 'left';
            }

        } else {
            $qcld_express_extra_class = "";
        }
        $html .= '<div class="qcld-express-row ' . $qcld_express_extra_class . '">';
        //SKu show or not
        if (isset($qcld_express_sku) && $qcld_express_sku == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-sku-cell"><p class="qcld-express-sku">' . $product->get_sku() . '</p></div>';
        }
        //Thumbnail show or not
        if (isset($qcld_express_thumbnail) && $qcld_express_thumbnail == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-thumb-cell"><p class="qcld-express-thumbnail"> <a href="' . get_permalink($P->ID) . '"><img class="qlcd-express-list-thumb" src="' . $image[0] . '"  alt="' . get_the_title($P->ID) . '"/></a></p></div>';
        }
        //Title show or not
        if (isset($qcld_express_title) && $qcld_express_title == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-title-cell"><h3 class="qcld-express-title"><a href="' . get_permalink($P->ID) . '">' . get_the_title($P->ID) . '</a></p></div>';
        }
        //Description show or not
        if (isset($qcld_express_description) && $qcld_express_description == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-desc-cell"><p class="qcld-express-desc">' . substr(get_the_excerpt($P->ID), 0, 65) . ' ...</p></div>';
        }
        //Availability show or not
        if (isset($qcld_express_stock) && $qcld_express_stock == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-avail-cell"><p class="qcld-express-avail">';
            if ($product->get_stock_status() == 'instock') {
                $html .= '<span class="qcld-express-avail-in"> In Stock </span>';
            } else {
                $html .= '<span class="qcld-express-avail-out"> Out of Stock</span>';
            }
            $html .= '</p></div>';
        }
        //Price show or not
        if (isset($qcld_express_price) && $qcld_express_price == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-price-cell"><p class="qcld-express-price">' . $product->get_price_html() . '</p></div>';
        }
        // Action show or not
        if (isset($qcld_express_action) && $qcld_express_action == 'on') {
            $html .= '<div class="qcld-express-cell qcld-express-action-cell"><p class="qcld-express-action">';
            if ($product->get_type() == 'simple') {
                $html .= '<button  type="button"  class="qcld_express_s_p" p-id="' . $P->ID . '"p-price="' . $product->get_price() . '" ><img src="'. QCLD_EXPRESS_IMG_URL .'/add-to-cart.png" width="60" height="30"/></button>';
            }
            if ($product->get_type() == 'variable') {
                $html .= '<button type="button" data-fancybox data-src="#qcld-express-modal-fancy" class="qcld_express_v_p qcld_express_config" p-id="' . $P->ID . '">Configure</button>';
            }
            $html .= '</p></div>';
        }//End of show or not
        $html .= '</div>';
        $counter++;
    } //End of loop
    $output = array('offset' => $nextOffset, 'html' => $html);
    echo wp_send_json($output);


}
