<?php
//checking qcld_express_shop is exist or not in the page.
function qcld_express_shortcode_check($posts) {
    if ( empty($posts) )
        return $posts;

    // false because we have to search through the posts first
    $found = false;

    // search through each post
    foreach ($posts as $post) {
        // check the post content for the short code
        if ( stripos($post->post_content, 'qcld_express_shop') )
            // Found a post with the short code
            $found = true;
        // stop the search
        break;
    }

    if ($found){
        //Load Script and Stylesheets
        add_action('wp_enqueue_scripts', 'qcld_express_load_front_scripts');
    }

    return $posts;
}
//perform the check when the_posts() function is called
add_action('the_posts', 'qcld_express_shortcode_check');
//Loading frontend style & scripts based on the above condition.
function qcld_express_load_front_scripts(){
    //Styles
    wp_enqueue_style( 'qcld_express_fontawesome_css', QCLD_EXPRESS_ASSETS_URL . '/css/font-awesome.min.css');
    wp_enqueue_style( 'qcld_express_front_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-custom-front.css');
    wp_enqueue_style( 'qcld_express_front_rwd_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-custom-front-rwd.css');
    wp_enqueue_style( 'qcld_express_slick_css', QCLD_EXPRESS_ASSETS_URL . '/css/qcld-express-slick.css');
    //Scripts
    wp_enqueue_script( 'jquery', 'jquery');
    wp_enqueue_script( 'qcld_express_fancybox_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-jquery.fancybox.min.js', array('jquery'));
    wp_enqueue_script( 'qcld_express_slick_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-slick.js', array('jquery'));
    wp_enqueue_script( 'qcld_express_front_js', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-custom-front.js', array('jquery','qcld_express_fancybox_js','qcld_express_slick_js'));
}
//Loading admin panel's requried Style & scripts
function qcld_express_load_admin_scripts(){
    //Styles
    wp_enqueue_style( 'qcld_express_admin_light_css', QCLD_EXPRESS_ASSETS_URL . "/css/qcld-express-custom-admin.css");
    wp_enqueue_style( 'wp-color-picker' );
    //Scripts
    wp_enqueue_script( 'qcld_express_wp_color_picker', QCLD_EXPRESS_ASSETS_URL . '/js/qcld-express-wp-color_picker.js', array( 'wp-color-picker' ), false, true );
    wp_enqueue_script( 'qcld_express_admin_js', QCLD_EXPRESS_ASSETS_URL . "/js/qcld-express-custom-admin.js", array('jquery'));
}
add_action( 'admin_enqueue_scripts', 'qcld_express_load_admin_scripts');